//Author Ethan McCorquodale

public class World
{
	// //removed unused variables such as all final states and tempChat = ' ' which can just be local
    public static final int SIZE = 10;
    private int locationIndex = 0; //creates a local index for the location array in the Display method. // changed from i since that's not a great name
    Location[] location = new Location[100];//an array that'll track each entities type,location coordinates and if it can move.
    int tempRow = 0;
    int tempColumn = 0;
    int oldRow;
    int oldCol;
    int turnSinceAtk;
    public Entity [][] aWorld;
    public boolean programRunning = true;
    
    GameStatus status = new GameStatus();
    // Post-condition: the position of the characters in the
    // starting input file will determine the position of the
    // objects in the array. The type of character in the file
    // determines the appearance of the Entity(O or D) or if the
    // element is empty (spaces become null elements)

	public World()
	{
		aWorld = new Entity[SIZE][SIZE]; // this is null anyway
		aWorld = FileInitialization.read();
		initializeGrid();
	}

	public void initializeGrid(){
		for (int row = 0; row < SIZE; row++){ // changed all instances of r and c so its more readable
			System.out.println("\n - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- "); // removed unnecessary print
			for (int column = 0; column < SIZE; column++){
				initializeLocations(row, column);
			}
			System.out.print("|");
		}
		System.out.println("\n - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- ");
		sortLocations();
	}

	public void initializeLocations(int row, int column){
		if (aWorld[row][column] == null) {
			System.out.print("| ");
			return;
		}
		char currentCellAppearance = aWorld[row][column].getAppearance();
		System.out.print("|"+currentCellAppearance);
		location[locationIndex] = new Location(row,column,currentCellAppearance);//Initializes each Entities location/type
		if (location[locationIndex].getType() == 'O') {//this checks the type and counts +1 if it's an orc
			Entity.incrementOrcCounter(1);
		}
		if (location[locationIndex].getType() == 'E') {
			Entity.incrementElfCounter(1);
		}
		locationIndex++;//Cause each initialization of the location[locationIndex] to go to the next element
	}

	public void sortDead() {//supposed to try and sort null elements and bring them to the end doesn't always work as intended
		for (int locationIndex = 0; locationIndex<=Entity.getElfCounter()+Entity.getOrcCounter();locationIndex++) {
			if (location[locationIndex] == null) {
				continue;
			}
			if((aWorld[location[locationIndex].getRow()][location[locationIndex].getColumn()] != null)||(location[locationIndex+1] == null)) {
				continue;
			}
			location[locationIndex] = location[locationIndex+1];
			location[locationIndex+1] = null;
			if(locationIndex-2 >= 0 && location[locationIndex-2]== null) {
				sortDead();
			}
		}
	}

	public void sortLocations() {//puts the elfs in the beginning of the array, checks if there is an orc before and elf and if there is it swaps positions in the array
		int orcCounter = Entity.getOrcCounter();
		for (int j = 0; j<Entity.getElfCounter()+orcCounter; j++) {
			if (location[j+orcCounter] == null){
				continue;
			}
			if(((location[j].getType() != 'O')||(location[j+orcCounter].getType() != 'E'))) {
				continue;
			}
			tempRow = location[j+orcCounter].getRow();
			tempColumn = location[j+orcCounter].getColumn();
			char tempType = location[j+orcCounter].getType();
			location[j+orcCounter].setType(location[j].getType());
			location[j+orcCounter].setColumn(location[j].getColumn());
			location[j+orcCounter].setRow(location[j].getRow());
			location[j].setRow(tempRow);
			location[j].setColumn(tempColumn);
			location[j].setType(tempType);
		}
	}
	public void attack(int index) {// new
		if(aWorld[tempRow][tempColumn] == null){
			return;
		}
		if((location[index].getType() == 'O') && (aWorld[tempRow][tempColumn].getAppearance() == 'O')) {
			return;
		}
		if((location[index].getType() == 'E') && (aWorld[tempRow][tempColumn].getAppearance() == 'E')) {
			return;
		}
		turnSinceAtk = 0;
		if((location[index].getType() == 'E')&&(aWorld[location[index].getRow()][location[index].getColumn()] != null)) {
			Entity attackingEntity = new Elf(); // Assuming Elf is a subclass of Entity
			attackLogic(attackingEntity, index);
		} else if((location[index].getType() == 'O')&&(aWorld[location[index].getRow()][location[index].getColumn()] != null)) {
			Entity attackingEntity = new Orc();
			attackLogic(attackingEntity, index);
		} else {
			location[index].setCanMove(true);
		}
	}

	public void attackLogic(Entity attackingEntity, int index){
		int entityDmg = attackingEntity.getDamage();
		int HP = aWorld[tempRow][tempColumn].getHitPoints();
		aWorld[tempRow][tempColumn].setHitPoints(aWorld[tempRow][tempColumn].getHitPoints()-entityDmg);
		int HPAfter = aWorld[tempRow][tempColumn].getHitPoints();

		if (GameStatus.debugModeOn) {//attack data for elf attackers
			attackingEntity.debugAttack(status, tempRow, tempColumn, location[index].getRow(), location[index].getColumn(),HP,HPAfter);
		}
		deathLogic(attackingEntity, index);
		victoryLogic(attackingEntity);
		if(GameStatus.debugModeOn) {//lose condition data
			if (attackingEntity instanceof Elf) {
				attackingEntity.debugLossConditions(status, Entity.getOrcCounter());
			} else if (attackingEntity instanceof Orc) {
				attackingEntity.debugLossConditions(status, Entity.getElfCounter());
			}
		}
	}

	public void deathLogic(Entity attackingEntity, int index){
		if (aWorld[tempRow][tempColumn].getHitPoints() >0){
			return;
		}
		aWorld[tempRow][tempColumn] = null;

		if (attackingEntity instanceof Elf) {
			Entity.incrementOrcCounter(-1);
		} else if (attackingEntity instanceof Orc) {
			Entity.incrementElfCounter(-1);
		}
		sortDead();
		if(location[index] != null) {
			location[index].setCanMove(true);
		}
	}

	public void victoryLogic(Entity attackingEntity){
		if (attackingEntity instanceof Elf) {
			if (Entity.getOrcCounter() > 0) {
				return;
			}
		}
		else if (attackingEntity instanceof Orc) {
			if (Entity.getElfCounter() > 0) {
				return;
			}
		}
//		System.out.println(attackingEntity.getClass().getSimpleName() + " wins, no more opponents left.");
//		System.out.println(attackingEntity + "win no more orcs left.");
		programRunning = false;
	}

	public boolean checkPerimeter(int index) {//looks at all the spaces around the current index of location[index] looking for things not null
		if (location[index] == null){
			return false;
		}
		for(int row = location[index].getRow()-1; row<location[index].getRow()+2;row++) {
			for(int column = location[index].getColumn()-1; column<location[index].getColumn()+2;column++ ) {
				if((row > 9)||(column > 9)||(row <= - 1)||(column <= -1)){ //ensuring row/column is in aWorld
					continue;
				}
				if((aWorld[row][column] == null) || (location[index].getType() == aWorld[row][column].getAppearance())) {
					continue;
				}
				location[index].setCanMove(false);
				tempRow = row;
				tempColumn = column;
				attack(index);
				return true;
			}
		}
		location[index].setCanMove(true);
		return false;
	}
	// these methods could be broken up into smaller ones
	public void move(int index) {//changes the value of aWorld[][] must set old position to null then update it to the new position.
		if (checkPerimeter(index)){ // changed syntax of if statement still needs to be true
			return;
		}
		if (location[index] == null) {
			return;
		}
		if (!location[index].getCanMove()){ // changed syntax of if statement still needs to be false
			return;
		}

		if((location[index].getRow()-1 != -1)&&(location[index].getColumn()-1 != -1)) {
			moveLogic('E', index, -1);
		}
		if((location[index].getRow()+1 != 10)&&(location[index].getColumn()+1 != 10)) {
			moveLogic('O', index, 1);
		}
		if ((GameStatus.debugModeOn)&&(location[index] != null)) { // changed syntax of if statement still needs to be true
			debugMovement(index);
		}
	}

	public void debugMovement(int index){
		if (location[index].getType() == 'E') {//elf move data
			status.elfMoveDebug(oldRow,oldCol,location[index].getRow(),location[index].getRow());
		} else if (location[index].getType() == 'O') {//orc move data
			status.orcMoveDebug(oldRow,oldCol,location[index].getRow(),location[index].getRow());
		}
	}

	public void moveLogic(char entityType, int index, int increment){
		if ((location[index].getType() == entityType)&&(aWorld[location[index].getRow()+ increment][location[index].getColumn()+increment]== null)) {
			oldRow = location[index].getRow();
			oldCol = location[index].getColumn();
			location[index].setRow(oldRow+increment);
			location[index].setColumn(oldCol+increment);
			aWorld[oldRow+increment][oldCol+increment] = aWorld[oldRow][oldCol];
			aWorld[oldRow][oldCol] = null;
		}
	}
}